import java.lang.Math;

public class Vector2D{
	private double x,y;
	
	public Vector2D(){
		this.x = 0.0;
		this.y = 0.0;
	}
	
	//constructor
	public Vector2D(double x, double y){
		this.x = x;
		this.y = y;
	}
	
	//sets the vector coords after its creation
	public void setCoords(double x, double y){
		this.x = x;
		this.y = y;
	}
	
	//gets x coord
	public double getx(){
		return  x;
	}
	
	//gets y coord
	public double gety(){
		return y;
	}
	
	//gets the magnitude of the vector
	public double mag(){
		return Math.sqrt(this.x*this.x + this.y*this.y);
	}
	
	//adds a vector to the object
	public void sumaVector(Vector2D other){;
		if (other != null){
			this.x += other.getx();
			this.y += other.gety();
		}
	}
	
	//makes the conversion from force to acceleration
	public Vector2D forcetoAccel(double mass){
			Vector2D a = new Vector2D(this.x/mass,this.y/mass);
			return a;
	}
	
	//makes the conversion from speed to position in delta_t time
	public Vector2D speedtoPos(double delta_t){
		Vector2D pos = new Vector2D(this.x*delta_t,this.y*delta_t);
		pos.setCoords(getx()*delta_t, gety()*delta_t);
		return pos;
	}
	
	//makes the conversion from acceleration to position in delta_t time
	public Vector2D acceltoPos(double delta_t){
		Vector2D pos = new Vector2D(this.x*delta_t*delta_t/2,this.y*delta_t*delta_t/2);
		return pos;
	}
	
	//makes the conversion from accel to speed in delta_t time
	public Vector2D acceltoSpeed(double delta_t){
		Vector2D speed = new Vector2D(this.x*delta_t,this.y*delta_t);
		return speed;
	}
	
	//returns the difference vector between the object and another vector
	public Vector2D diffVector(Vector2D other){
		Vector2D diff = new Vector2D();
		double auxx,auxy;
		if (other != null){
			auxx = this.x - other.getx();
			auxy = this.y - other.gety();
			diff.setCoords(auxx,auxy);
		}
		return diff;
	}
	
	//gets the angle formed by the vector (it has a range from [-pi/2,pi/2], so the vectors from quadrants 3 and 4 are moved to quadrants 2 and 1 respectively)
	public double getAngle(){
		if(x==0){
			if (y>=0)
				return Math.PI/2;
			else
				return 3*Math.PI/2;
		}
		
		return Math.atan(y/x);
	}
	
	//gets the quadrant where the vector is (considering it starts in (0,0))
	public int getQuadrant(){
		if(this.x>=0){
			if (this.y>=0)	return 1;
			else	return 2;
		}
		else{
			if(this.y>=0)	return 4;
			else			return 3;
		}
	}
}
